
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Nginx学习笔记六Nginx的模块开发 / 憋错料</title>

    <meta name="description" content="Nginx学习笔记六Nginx的模块开发 1.Nginx配置文件主要组成:main(全局配置)这部分的指令将影响其他所有部分.server(虚拟主机配置)这部分指令主要用于指定虚拟主机域名,IP和端口.upstream(主要为反向代理,负载均衡相关配置)这部分指令用于设置反向代理及后端服务 器的负载均衡.location(目录匹配配置)这部分指令用于匹配网页位置(例如,根目录&quot;/&quot;,&quot;/images&quot;,等 等). location部分会继承server部分的指令,而server部分会继承main部 ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">Nginx学习笔记六Nginx的模块开发</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>1.Nginx配置文件主要组成:<br />main(全局配置)这部分的指令将影响其他所有部分.<br />server(虚拟主机配置)这部分指令主要用于指定虚拟主机域名,IP和端口.<br />upstream(主要为反向代理,负载均衡相关配置)这部分指令用于设置反向代理及后端服务</p>
<p>器的负载均衡.<br />location(目录匹配配置)这部分指令用于匹配网页位置(例如,根目录"/","/images",等</p>
<p>等).</p>
<p>location部分会继承server部分的指令,而server部分会继承main部分的指令.upstream</p>
<p>既不会继承指令也不会影响其他部分.它有自己的特殊指令,不需要在其他地方应用.</p>
<p>2.Nginx模块概述.<br />Nginx的模块不能够像Apache那样动态添加,所有的模块都要预先编译进Nginx的二进制可</p>
<p>执行文件中.Nginx模块有三种角色.<br />(1)Handlers(处理模块)&mdash;&mdash;用于处理HTTP请求并输出内容.<br />(2)Filters(过滤模块)&mdash;&mdash;用于过滤Handler输出的内容.<br />(3)Load-balancers(负载均衡模块)&mdash;&mdash;当有多于一台的后端服务器供选择时，选择一台</p>
<p>后端服务器并将HTTP请求转发到该服务器.</p>
<p>3.Nginx模块的处理流程:<br />Nginx发送文件或请求到其他服务器时,可以用Handlers处理模块为其服务:当需要Nginx</p>
<p>把输出压缩或在服务端加一些东西时,可以用Filters过滤模块.Nginx的核心模块主要管</p>
<p>理网络层和应用层协议,以及启动针对特定应用的一系列候选模块.</p>
<p>客户端发送HTTP请求到Nginx服务器<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;|<br />Nginx基于配置文件中的位置选择一个合适的处理模块&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;|<br />负载均衡模块选择一台后端服务器(反向代理情况下)<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;|<br />处理模块进行处理并把输出缓冲放到第一个过滤模块上<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;|<br />第一个过滤模块处理后输出给第二个过滤模块<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;|<br />然后第二个过滤模块又到了第三个过滤模块<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;|<br />&nbsp;&nbsp;&nbsp;&nbsp;第Ｎ个过滤模块<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;｜<br />最后把处理结果发送给客户端</p>
<p>4.模块执行的位置<br />模块相当于钩子,可以挂在Nginx的以下位置,在某些时候执行某些功能.<br />(1)当服务读配置文件之前.<br />(2)当读取在location和server部分或其他任何部分的每一个配置指令时。<br />(3)当Nginx初始化全局部分的配置时.<br />(4)当Nginx初始化主机部分(比如主机/端口)的配置时.<br />(5)当Nginx将全局部分的配置与主机部分的配置合并时.<br />(6)当Nginx初始化匹配位置部分配置时.<br />(7)当Nginx将其上层主机配置与位置部分配置合并时.<br />(8)当Nginx的主进程(master)开始时.<br />(9)当一个新的工作进程(worker)开始时.<br />(10)当一个工作进程退出时.<br />(11)当主进程退出时.<br />(12)处理HTTP请求时.<br />(13)过滤HTTP回复的头部时.<br />(14)过滤HTTP回复的主体时.<br />(15)选择一台后端服务器时.<br />(16)初始化到后端服务器的请求时.<br />(17)重新初始化到后端服务器的请求时.<br />(18)处理来自后端服务器的回复时.<br />(19)完成与后端服务器的交互时.</p>
<p>5.Nginx模块编写例子<br />(1)执行以下命令创建一个目录,将在该目录内编写我们的Nginx模块:<br />mkdir -p /opt/nginx_hello_world<br />cd /opt/nginx_hello_world<br />(2)开始创建Nginx模块所需的配置文件(名称为config)<br />vi /opt/nginx_hello_world/config<br />输入以下内容并保存退出.<br />ngx_addon_name=ngx_http_hello_world_module<br />HTTP_MODULES="$HTTP_MODULES ngx_http_hello_world_module"<br />NGX_ADDON_SRCS="$NGX_ADDON_SRCS $ngx_addon_dir/ngx_http_hello_world_module.c"<br />CORE_LIBS="$CORE_LIBS -lpcre"<br />(3)创建Nginx模块的c程序文件(名称格式为"ngx_http_模块名称_module.c",在本实例中</p>
<p>,文件名称为ngx_http_hello_world_module.c)<br />vi /opt/nginx_hello_world/ngx_http_hello_world_module.c<br />(4)下载Nginx源码包,并将hello world模块编译到其中.如下所示<br />wget ftp://ftp.csx.cam.ac.uk/pub/software/programming/pcre/pcre-7.9.tar.gz<br />tar zxvf pcre-7.9.tar.gz<br />cd pcre-7.9/<br />./configure<br />make &amp;&amp; make install<br />cd ../</p>
<p>wget http://sysoev.ru/nginx/nginx-0.8.14.tar.gz<br />tar zxvf nginx-0.8.14.tar.gz<br />cd nginx-0.8.14/<br />./configure --prefix=/usr/local/nginx --add-module=/opt/nginx_hello_world<br />make<br />make install<br />(5)配置nginx.conf,在server部分增加以下内容:<br />location = /hello {<br />&nbsp;&nbsp;hello_world ;<br />}<br />(6)启动Nginx，用浏览器访问http://localhost/hello，就可以看到编写的Nginx Hello</p>
<p>World 模块输出的文字"Hello World"</p>
<p>6.Hello World模块分析:<br />在ngx_http_hello_world_module.c代码中,ngx_command_t函数用于定义包含模块指令的</p>
<p>静态数组ngx_http_hello_world_commands，代码如下<br />static ngx_command_t ngx_http_hello_world_commands[] =<br />{<br />&nbsp;{<br />&nbsp;&nbsp;ngx_string ("hello_world"),<br />&nbsp;&nbsp;NGX_HTTP_LOC_CONF|NGX_CONF_NOARGS,<br />&nbsp;&nbsp;ngx_http_hello_world,<br />&nbsp;&nbsp;0,<br />&nbsp;&nbsp;0,<br />&nbsp;&nbsp;NULL<br />&nbsp;},<br />&nbsp;ngx_null_command<br />}</p>
<p>(1)在数组中,第一项参数ngx_string("hello_world")为指令名称字符串,不能含有空格,</p>
<p>数据类型是ngx_str_t,经常用来进行字符串实例化.ngx_str_t结构体由包含有字符串的</p>
<p>data成员和表示字符串长度的len成员组成.Nginx用这个数据类型来存放字符串.<br />(2)第二项参数用来设置指令在配置文件位置的哪一部分使用是合法的.可选值如下,多个</p>
<p>选项以"|"隔开:<br />NGX_HTTP_MAIN_CONF&mdash;&mdash;指令出现在全局配置部分是合法的.<br />NGX_HTTP_SRV_CONF&mdash;&mdash;指令出现在server主机配置部分是合法的.<br />NGX_HTTP_LOC_CONF&mdash;&mdash;指令出现在location配置部分是合法的.<br />NGX_HTTP_UPS_CONF&mdash;&mdash;指令出现在upstream配置部分是合法的.<br />(3)第三项参数ngx_http_hello_world是一个回调函数.<br />(4)第四项参数用于告诉Nginx是把要保持的值放在全局配置部分,server主机配置部分还</p>
<p>是location位置配置部分(使用NGX_HTTP_MAIN_CONF_OFFSET，</p>
<p>NGX_HTTP_SRV_CONF_OFFSET,NGX_HTTP_LOC_CONF_OFFSET)<br />(5)第五项参数用于设置指令的值保存在结构体的哪个位置<br />(6)第六项参数一般为NULL。<br />六个参数都设置完毕后，数组在读入ngx_null_command后停止.</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-20 12:05:28 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>Nginx学习笔记六Nginx的模块开发的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MDmoop0.html" rel="bookmark">Python学习笔记六（常用模块、面向对象基础）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.random模块 import random print(random.random()) #0-1之间的小数 print(random.randint(1,5)) #1-5之间(包括1和5)的整数 print(random.randrange(1,5)) #1-5之间(包含1,不好包含5)的整数 print(random.choice(['a','b','c'])) #给定列表中任意元素 print(random.sample(['a','b','c','d'],2)) #给定列表中任意n			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/41DEmY3.html" rel="bookmark">nginx学习笔记之基于端口的虚拟主机基于主机名的虚拟主机root、alias、index配置</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				nginx学习笔记之基于端口的虚拟主机基于主机名的虚拟主机root.alias.index配置 实验环境: centos 测试节点IP:172.16.3.101 基于端口的虚拟主机: vim /etc/nginx/nginx.conf # 向里面的http {}里面加入如下内容   server { # server定义一个虚拟主机         listen 8080; # 监听本机所有IP端口8080         server_name www.test.com; # 虚拟主机名为:w			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0n1gv7M.html" rel="bookmark">&lbrack;Pro Angular&period;JS&rsqb;学习笔记1&period;1：设置开发环境</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				可以使用yeoman.io,很方便.我已经写了一篇随笔,介绍如何使用.这里也有一篇介绍的文章:http://www.cnblogs.com/JoannaQ/p/3756281.html 代码编辑器,在Mac下用了一下WebStorm,太恶心了.另外发现书的作者使用的开发环境是Windows + VS Express 2013,为了方便学习,我也使用VS Express 2013 Update2.VS2013用起来蛮舒服的,把WebStorm比得跟驼屎一样.也许是因为我没用习惯吧. 1.安装Nod			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MEjlGP0.html" rel="bookmark">初探swift语言的学习笔记六&lpar;ARC-自动引用计数&comma;内存管理&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Swift使用自动引用计数(ARC)来管理应用程序的内存使用.这表示内存管理已经是Swift的一部分,在大多数情况下,你并不需要考虑内存的管理.当实例并不再被需要时,ARC会自动释放这些实例所使用的内存. 另外需要注意的: 引用计数仅仅作用于类实例上.结构和枚举是值类型,而非引用类型,所以不能被引用存储和传递. swift的ARC工作过程 每当创建一个类的实例,ARC分配一个内存块来存储这个实例的信息,包含了类型信息和实例的属性值信息. 另外当实例不再被使用时,ARC会释放实例所占用的内存,这些			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0kjLkXM.html" rel="bookmark">laravel3学习笔记&lpar;六&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原作者博客:ieqi.net ==================================================================================================== ORM Laravel3中MVC体系中Model里最重要的组成部分无疑是ORM了,ORM — object-relational mapper — 将数据操作面向对象化,使得整个web框架的核心风格统一,降低整体复杂度,为开发者提供便利. Laravel3中的ORM叫			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/r4JoZ9M.html" rel="bookmark">python之raw&lowbar;input&lpar;&rpar;（学习笔记六）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				python之raw_input()(学习笔记六) 我们经常使用raw_input()读取用户的输入,如下例子所示: &gt;&gt;&gt; name = raw_input('please input your name:'),截图如下: 下面简单说下,raw_input()与if搭配使用,脚本如下: #!/usr/bin/env python # -*- coding:utf-8 -*- birth = raw_input('birth:') if birth &lt; 2000: print '0			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0KamyK4.html" rel="bookmark">Linux 程序设计学习笔记----进程管理与程序开发（下）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				转载请注明出处:http://blog.csdn.net/suool/article/details/38419983,谢谢! 进程管理及其控制 创建进程 fork()函数 函数说明具体参见:http://pubs.opengroup.org/onlinepubs/009695399/functions/fork.html 返回值:Upon successful completion, fork() shall return 0 to the child process and shall re			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0leywB3.html" rel="bookmark">swift学习笔记&lpar;六&rpar;析构过程和使用闭包对属性进行默认值赋值</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.通过闭包和函数实现属性的默认值 当某个存储属性的默认值需要定制时,可以通过闭包或全局函数来为其提供定制的默认值. 注:全局函数结构体和枚举使用关键字static标注    函数则使用class关键字标注 当对一个属性使用闭包函数进行赋值时,每当此属性所述的类型被创建实例时,对应的闭包或函数会被调用,而他们的返回值会被作为属性的默认值. ESC: Class SomeCLass{ let someProperty:SomeType={ //给someProperty赋一个默认值 //返回一个与			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/02yb2BM.html" rel="bookmark">java之jvm学习笔记六-十二&lpar;实践写自己的安全管理器&rpar;&lpar;jar包的代码认证和签名&rpar; &lpar;实践对jar包的代码签名&rpar; &lpar;策略文件&rpar;&lpar;策略和保护域&rpar;  &lpar;访问控制器&rpar; &lpar;访问控制器的栈校验机制&rpar; &lpar;jvm基本结构&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				java之jvm学习笔记六(实践写自己的安全管理器) 安全管理器SecurityManager里设计的内容实在是非常的庞大,它的核心方法就是checkPerssiom这个方法里又调用 AccessController的checkPerssiom方法,访问控制器AccessController的栈检查机制又遍历整个 PerssiomCollection来判断具体拥有什么权限一旦发现栈中一个权限不允许的时候抛出异常否则简单的返回,这个过程实际上比我的描述要复杂 得多,这里我只是简单的一句带过,因为这			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/yMX5mb0.html" rel="bookmark" class="title">方法动手动脑及实验</a>
					<div>
						一.SquareInt.java public class SquareInt { public static void main(String[] args) { int result; for ( ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/E3wb5b0.html" rel="bookmark" class="title">第四题</a>
					<div>
											</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWwAOrM.html" rel="bookmark" class="title">log4net的使用</a>
					<div>
						程序中只需要引用log4net.dll文件即可 配置的引用 log4net.Config.XmlConfigurator.Configure(); 首先添加以上代码. CS程序:在Main方法中添加: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MmlzYK4.html" rel="bookmark" class="title">css -- 布局元素</a>
					<div>
						默认情况下拥有布局的元素:HTML ,table,tr,td,img,hr,input,select,textarea,button,iframe,embed,object,applet,marque ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3OaG5ZM.html" rel="bookmark" class="title">cnblogs中测试latex</a>
					<div>
						\Gamma(z) = \int_0^\infty t^{z-1}e^{-t}dt\					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MVYxPk4.html" rel="bookmark" class="title">HDU 1800 字典树</a>
					<div>
						Flying to the Mars Time Limit: 5000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Other ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mg5rQN3.html" rel="bookmark" class="title">杂文 - 设计MIUI主题 的 MIUI设计师</a>
					<div>
						设计MIUI主题 的 MIUI设计师 本文地址: http://blog.csdn.net/caroline_wendy 时间: 2014.6.10 By Spike. 1. 首先注冊MIUI设计师: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/ME8oBD4.html" rel="bookmark" class="title">天际星云</a>
					<div>
						天际星云(Skylae,Inc.)专注于研发先进的互联网技术,拥有自主研发技术平台和顶尖技术团队. 天际星云一直以技术为核心,以用户需求为导向,云致力于为用户提供完整技术解决方案,为用户带来前所未有的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPDxXDM.html" rel="bookmark" class="title">jersy服务，将图片发送另个服务器，再将异步返回</a>
					<div>
						今天在学习新项目时,遇到了jersy服务,完成,将图片发送到另一台服务器.下面介绍一下jersy服务的一个简单例子. 1.建立一个jersy一个java项目,先导入jersy服务相应的jar包 com ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ONjy90.html" rel="bookmark" class="title">mybatis从dao传入多个参数到sqlmap时dao中要使用map或实例对象&lpar;如&colon;user&rpar;作为参数传入&comma; 否则报错找不到属性getter方法</a>
					<div>
						23:37 2015-07-02 注意1. 使用mybaits的resultMap查询时, 如果想传入多个参数(比如where 1=1动态多条件查询时)sqlmap文件中对应的方法中, selectL ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBaAXg4.html" rel="bookmark" class="title">FAFU 1557</a>
					<div>
						构建字典序,模拟二叉树建26叉树 1 #include &lt;stdio.h&gt; 2 #include &lt;string.h&gt; 3 #include &lt;stdlib.h&gt;  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4JYQan3.html" rel="bookmark" class="title">Android应用项目中BaseAdapter、SimpleAdapter和ArrayAdapter中的三种适配器</a>
					<div>
						一.写在前面: 本次我们来讲解一下Android应用中三个适配器:BaseAdapter.SimpleAdapter和ArrayAdapter.其中常见的是BaseAdapter,也是个人推荐使用的适 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0dNXg74.html" rel="bookmark" class="title">java中的复制数组arraycopy&lpar;&rpar;</a>
					<div>
						System.arraycopy();//静态方法,在System类中定义,注意copy首字母是小写的 例子: int[] a = {1,2,3,4,5}; int[] b = {9,8,7,6};  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4Q7wEN0.html" rel="bookmark" class="title">Spring data jpa使用枚举</a>
					<div>
						枚举的优越性不用多说.在实体中使用,上代码 实体类: @Entity @Table(name = &quot;cache_user&quot;) public class User { /** * 用 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3vzPqk3.html" rel="bookmark" class="title">NOIP2000进制转换</a>
					<div>
						题目描述 我们可以用这样的方式来表示一个十进制数: 将每个阿拉伯数字乘以一个以该数字所处位置的(值减1)为指数,以10为底数的幂之和的形式.例如:123可表示为 1*10^2+2*10^1+3*10^ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MV71Yj0.html" rel="bookmark" class="title">代理模式的相关使用</a>
					<div>
						本例子主要是处理request编码问题 public void doFilter(ServletRequest request, ServletResponse response, FilterCha ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mm9K7DM.html" rel="bookmark" class="title">ASP&period;NET将word文档转换成pdf的代码</a>
					<div>
						一.添加引用 using Microsoft.Office.Interop.Word; 二.转换方法 1.方法 C# 代码   复制 /// &lt;summary&gt; /// 把Word文件转换 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xBznr4.html" rel="bookmark" class="title">NSArray函数</a>
					<div>
						1.判断是否包含某一个元素,返回1则表示有 - (BOOL)countainsObject:(id)anObject BOOL isContain = [arrayboy containsObject ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pNwvx0.html" rel="bookmark" class="title">以大欺小？各国人民都笑了</a>
					<div>
						http://www.zhihu.com/people/eynks04626/collectionshttp://www.zhihu.com/people/jjpnb66600http://www.z ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0d2QK64.html" rel="bookmark" class="title">nth-child和蝉原则实现的奇妙随机效果（译）</a>
					<div>
						此文翻译自charlotte jackson的&lt;Magic randomisation with nth-child and Cicada Principle&gt; 在做伪装的随机模式时将nt ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.030 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
